|
@@ -0,0 +1,124 @@
|
|
|
|
+#! /bin/sh
|
|
|
|
+### BEGIN INIT INFO
|
|
|
|
+# Provides: stdd
|
|
|
|
+# Required-Start: $syslog
|
|
|
|
+# Required-Stop: $syslog
|
|
|
|
+# Default-Start: 2 3 4 5
|
|
|
|
+# Default-Stop: 0 1 6
|
|
|
|
+# Short-Description: stdd - the simple time display daemon
|
|
|
|
+# Description: Init script for stdd, the simple time
|
|
|
|
+# display daemon written for the Raspberry PI.
|
|
|
|
+### END INIT INFO
|
|
|
|
+
|
|
|
|
+# Author: Helmut Pozimski <helmut@pozimski.eu>
|
|
|
|
+
|
|
|
|
+
|
|
|
|
+# PATH should only include /usr/* if it runs after the mountnfs.sh script
|
|
|
|
+PATH=/sbin:/usr/sbin:/bin:/usr/bin
|
|
|
|
+DESC="The simple time display daemon"
|
|
|
|
+NAME="stdd"
|
|
|
|
+DAEMON=/usr/sbin/$NAME
|
|
|
|
+DAEMON_ARGS="-d -c /etc/stdd.conf -u $STDD_USER -g $STDD_GROUP"
|
|
|
|
+SCRIPTNAME=/etc/init.d/$NAME
|
|
|
|
+
|
|
|
|
+if [ -d /run ]; then
|
|
|
|
+ PIDFILE=/run/stdd
|
|
|
|
+else
|
|
|
|
+ PIDFILE=/var/run/stdd
|
|
|
|
+fi
|
|
|
|
+
|
|
|
|
+# Exit if the package is not installed
|
|
|
|
+[ -x "$DAEMON" ] || exit 0
|
|
|
|
+
|
|
|
|
+# Read configuration variable file if it is present
|
|
|
|
+[ -r /etc/default/$NAME ] && . /etc/default/$NAME
|
|
|
|
+
|
|
|
|
+# Load the VERBOSE setting and other rcS variables
|
|
|
|
+. /lib/init/vars.sh
|
|
|
|
+
|
|
|
|
+# Define LSB log_* functions.
|
|
|
|
+# Depend on lsb-base (>= 3.2-14) to ensure that this file is present
|
|
|
|
+# and status_of_proc is working.
|
|
|
|
+. /lib/lsb/init-functions
|
|
|
|
+
|
|
|
|
+#
|
|
|
|
+# Function that starts the daemon/service
|
|
|
|
+#
|
|
|
|
+do_start()
|
|
|
|
+{
|
|
|
|
+ # Return
|
|
|
|
+ # 0 if daemon has been started
|
|
|
|
+ # 1 if daemon was already running
|
|
|
|
+ # 2 if daemon could not be started
|
|
|
|
+ start-stop-daemon --status --quiet --pidfile $PIDFILE > /dev/null \
|
|
|
|
+ || return 1
|
|
|
|
+ start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON -- \
|
|
|
|
+ $DAEMON_ARGS \
|
|
|
|
+ || return 2
|
|
|
|
+}
|
|
|
|
+
|
|
|
|
+#
|
|
|
|
+# Function that stops the daemon/service
|
|
|
|
+#
|
|
|
|
+do_stop()
|
|
|
|
+{
|
|
|
|
+ # Return
|
|
|
|
+ # 0 if daemon has been stopped
|
|
|
|
+ # 1 if daemon was already stopped
|
|
|
|
+ # 2 if daemon could not be stopped
|
|
|
|
+ # other if a failure occurred
|
|
|
|
+ start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE
|
|
|
|
+ RETVAL="$?"
|
|
|
|
+ return "$RETVAL"
|
|
|
|
+}
|
|
|
|
+
|
|
|
|
+
|
|
|
|
+case "$1" in
|
|
|
|
+ start)
|
|
|
|
+ [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
|
|
|
|
+ do_start
|
|
|
|
+ case "$?" in
|
|
|
|
+ 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
|
|
|
|
+ 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
|
|
|
|
+ esac
|
|
|
|
+ ;;
|
|
|
|
+ stop)
|
|
|
|
+ [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
|
|
|
|
+ do_stop
|
|
|
|
+ case "$?" in
|
|
|
|
+ 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
|
|
|
|
+ 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
|
|
|
|
+ esac
|
|
|
|
+ ;;
|
|
|
|
+ status)
|
|
|
|
+ status_of_proc "$DAEMON" "$NAME" && exit 0 || exit $?
|
|
|
|
+ ;;
|
|
|
|
+ restart|force-reload)
|
|
|
|
+ #
|
|
|
|
+ # If the "reload" option is implemented then remove the
|
|
|
|
+ # 'force-reload' alias
|
|
|
|
+ #
|
|
|
|
+ log_daemon_msg "Restarting $DESC" "$NAME"
|
|
|
|
+ do_stop
|
|
|
|
+ case "$?" in
|
|
|
|
+ 0|1)
|
|
|
|
+ do_start
|
|
|
|
+ case "$?" in
|
|
|
|
+ 0) log_end_msg 0 ;;
|
|
|
|
+ 1) log_end_msg 1 ;; # Old process is still running
|
|
|
|
+ *) log_end_msg 1 ;; # Failed to start
|
|
|
|
+ esac
|
|
|
|
+ ;;
|
|
|
|
+ *)
|
|
|
|
+ # Failed to stop
|
|
|
|
+ log_end_msg 1
|
|
|
|
+ ;;
|
|
|
|
+ esac
|
|
|
|
+ ;;
|
|
|
|
+ *)
|
|
|
|
+ echo "Usage: $SCRIPTNAME {start|stop|status|restart|force-reload}" >&2
|
|
|
|
+ exit 3
|
|
|
|
+ ;;
|
|
|
|
+esac
|
|
|
|
+
|
|
|
|
+:
|